# AmoebaStretchBendForce Class Reference

This class implements the Amoeba stretch-bend interaction. More...

`#include <AmoebaStretchBendForce.h>`

Inheritance diagram for AmoebaStretchBendForce:

List of all members.

## Classes

class | StretchBendInfo
| This is an internal class used to record information about a stretch-bend.

## Public Member Functions

| AmoebaStretchBendForce ()
| Create an AmoebaStretchBendForce.
int | getNumStretchBends () const
| Get the number of stretch-bend terms in the potential function.
int | addStretchBend (int particle1, int particle2, int particle3, double lengthAB, double lengthCB, double angle, double k)
| Add a stretch-bend term to the force field.
void | getStretchBendParameters (int index, int &particle1, int &particle2, int &particle3, double &lengthAB, double &lengthCB, double &angle, double &k) const
| Get the force field parameters for a stretch-bend term.
void | setStretchBendParameters (int index, int particle1, int particle2, int particle3, double lengthAB, double lengthCB, double angle, double k)
| Set the force field parameters for a stretch-bend term.
void | updateParametersInContext (Context &context)
| Update the per-stretch-bend term parameters in a Context to match those stored in this Force object.

## Protected Member Functions

ForceImpl * | createImpl () const
| When a Context is created, it invokes this method on each Force in the System.

## Detailed Description

This class implements the Amoeba stretch-bend interaction.

To use it, create a StretchBendForce object then call addStretchBend() once for each stretch-bend. After a stretch-bend has been added, you can modify its force field parameters by calling setStretchBendParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext().

## Constructor & Destructor Documentation

AmoebaStretchBendForce | ( |  | ) |

Create an AmoebaStretchBendForce.

## Member Function Documentation

int addStretchBend | ( | int | particle1,
|  | int | particle2,
|  | int | particle3,
|  | double | lengthAB,
|  | double | lengthCB,
|  | double | angle,
|  | double | k |
| ) |  |  |

Add a stretch-bend term to the force field.

Parameters:

  | particle1 | the index of the first particle connected by the stretch-bend
  | particle2 | the index of the second particle connected by the stretch-bend
  | particle3 | the index of the third particle connected by the stretch-bend
  | lengthAB | the equilibrium length of the stretch-bend in bond ab [particle1, particle2], measured in nm
  | lengthCB | the equilibrium length of the stretch-bend in bond cb [particle3, particle2], measured in nm
  | angle | the equilibrium angle in radians
  | k | the force constant for the stretch-bend

Returns:
  the index of the stretch-bend that was added

ForceImpl* createImpl | ( |  | ) | const`[protected, virtual]`

When a Context is created, it invokes this method on each Force in the System.

It should create a new ForceImpl object which can be used by the context for calculating forces. The ForceImpl will be deleted automatically when the Context is deleted.

Implements Force.

int getNumStretchBends | ( |  | ) | const`[inline]`

Get the number of stretch-bend terms in the potential function.

void getStretchBendParameters | ( | int | index,
|  | int & | particle1,
|  | int & | particle2,
|  | int & | particle3,
|  | double & | lengthAB,
|  | double & | lengthCB,
|  | double & | angle,
|  | double & | k |
| ) |  |  | const

Get the force field parameters for a stretch-bend term.

Parameters:

  | index | the index of the stretch-bend for which to get parameters
  | particle1 | the index of the first particle connected by the stretch-bend
  | particle2 | the index of the second particle connected by the stretch-bend
  | particle3 | the index of the third particle connected by the stretch-bend
  | lengthAB | the equilibrium length of the stretch-bend in bond ab [particle1, particle2], measured in nm
  | lengthCB | the equilibrium length of the stretch-bend in bond cb [particle3, particle2], measured in nm
  | angle | the equilibrium angle in radians
  | k | the force constant for the stretch-bend

void setStretchBendParameters | ( | int | index,
|  | int | particle1,
|  | int | particle2,
|  | int | particle3,
|  | double | lengthAB,
|  | double | lengthCB,
|  | double | angle,
|  | double | k |
| ) |  |  |

Set the force field parameters for a stretch-bend term.

Parameters:

  | index | the index of the stretch-bend for which to set parameters
  | particle1 | the index of the first particle connected by the stretch-bend
  | particle2 | the index of the second particle connected by the stretch-bend
  | particle3 | the index of the third particle connected by the stretch-bend
  | lengthAB | the equilibrium length of the stretch-bend in bond ab [particle1, particle2], measured in nm
  | lengthCB | the equilibrium length of the stretch-bend in bond cb [particle3, particle2], measured in nm
  | angle | the equilibrium angle in radians
  | k | the force constant for the stretch-bend

void updateParametersInContext | ( | Context & | context | ) |

Update the per-stretch-bend term parameters in a Context to match those stored in this Force object.

This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setStretchBendParameters() to modify this object's parameters, then call updateParametersInState() to copy them over to the Context.

The only information this method updates is the values of per-stretch-bend term parameters. The set of particles involved in a term cannot be changed, nor can new terms be added.

The documentation for this class was generated from the following file:

- AmoebaStretchBendForce.h